{ stdenv, fetchFromGitHub, postgresql, flex }:

stdenv.mkDerivation rec {
  pname = "pg_tle";
  version = "1.0.4";

  nativeBuildInputs = [ flex ];
  buildInputs = [ postgresql ];

  src = fetchFromGitHub {
    owner  = "aws";
    repo   = pname;
    rev    = "refs/tags/v${version}";
    hash   = "sha256-W/7pLy/27VatCdzUh1NZ4K2FRMD1erfHiFV2eY2x2W0=";
  };

  makeFlags = [ "FLEX=flex" ];

  installPhase = ''
    mkdir -p $out/{lib,share/postgresql/extension}

    cp *.{dylib,so} $out/lib
    cp *.sql        $out/share/postgresql/extension
    cp *.control    $out/share/postgresql/extension
  '';
}
